# -*- coding: utf-8 -*-
"""
Created on Fri Sep 30 09:15:59 2022

@author: mauri
"""

import matplotlib.pyplot as plt
import matplotlib.animation as animation
import numpy as np
from standards import standard_constants
from standards import standard_variables
from Real_max_sig_noise import signal_to_noise_max
from matplotlib.animation import PillowWriter
variables=standard_variables()
constants=standard_constants()
import seaborn as sns
from matplotlib import colors
cols = ["#F82584","#530656","#4460EF","#4CCAF1"]
sns.set_palette(cols)
cmap = colors.LinearSegmentedColormap.from_list("", cols)
line = ["-","--","-.",":"]

def data_gen(variables, constants):
    Kd_BlcR_DNA=constants[3]
    ## load variables
    log_min_Kd_BlcR_DNA=variables[4]
    log_max_Kd_BlcR_DNA=variables[5]
    ## load arrays
    time_text = ax.text(0.65, 0.9, '', transform=ax.transAxes)
    Length=110
    kd=[0]*Length
    x=[0]*Length
    z =[0]*Length
    Kd_BlcR_DNA_00=np.logspace((log_min_Kd_BlcR_DNA),(log_max_Kd_BlcR_DNA),Length-20)
    Kd_BlcR_DNA_0=np.append(Kd_BlcR_DNA_00,[(395*10**-9) ,(395*10**-9) ,(395*10**-9),(395*10**-9) ,(395*10**-9) ,(395*10**-9),(395*10**-9),(395*10**-9) ,(395*10**-9),(395*10**-9),(395*10**-9) ,(395*10**-9) ,(395*10**-9),(395*10**-9) ,(395*10**-9) ,(395*10**-9),(395*10**-9),(395*10**-9) ,(395*10**-9),(395*10**-9) ])
    print(Kd_BlcR_DNA_0)
    for j in range(Length):
        Kd_BlcR_DNA=(Kd_BlcR_DNA_0[-j-1])**2
        Frac_cap, Ca_00, lowerbound=signal_to_noise_max(variables,constants,Kd_BlcR_DNA)
        x[j]=lowerbound
        z[j]=max(Frac_cap)
        kd[j]=Kd_BlcR_DNA_0[-j-1]
    for i in range(Length):
        t = x[i] #Ca_0[i]
        y=z[i]  #fb1[i]
        L=round((Kd_BlcR_DNA_0[-i-1])*10**9,1)
        print(L)
        time_template = 'Kd = %.1f[nM]'
        time_text.set_text(time_template % L)
        yield t,y, time_text
    
def init():
    ax.set_ylim(100, 140000)
    ax.set_xlim(3*10**-8, 10**-4.75)
    del xdata[:]
    del ydata[:]
    line.set_data(xdata, ydata)
    return line,

fig, ax = plt.subplots()
line, = ax.plot([], [], lw=2)
ax.grid()
xdata, ydata = [], []

def run(data):
    # update the data
    t, y, time = data
    xdata.append(t)
    ydata.append(y)
    xmin, xmax = ax.get_xlim()
    if t >= xmax:
        ax.set_xlim(xmin, 2*xmax)
        ax.figure.canvas.draw()
    line.set_data(xdata, ydata)
    return line

plt.xscale("log")
plt.xlabel("Concentration BlcR [M]")
plt.ylabel("signal to noise ratio") 
anim = animation.FuncAnimation(fig, run, data_gen(variables, constants), interval=10, init_func=init)
writer = PillowWriter(fps=30)
plt.show()



