# -*- coding: utf-8 -*-
"""
Created on Mon Jul  4 16:23:10 2022

@author: mauri
"""

from standards import standard_constants
from standards import standard_variables
from Data_fb import fb
from data_vary_kd_BlcR_DNA import vary_kd_BlcR_DNA
from data_vary_Kd_BlcR_GHB import vary_Kd_BlcR_GHB
import matplotlib.pyplot as plt
from data_sensitivity import sensitivity
from data_signal_to_noise import signal_to_noise
from Real_max_sig_noise import signal_to_noise_max
from data_sens_kd import sensitivity_kds
import seaborn as sns
from matplotlib import colors

cols = ["#F82584","#530656","#4460EF","#4CCAF1"]
sns.set_palette(cols)
cmap = colors.LinearSegmentedColormap.from_list("", cols)
line = ["-","--","-.",":"]

def plot_fb():
    variables=standard_variables()
    constants=standard_constants()
    fb1,fb2,Ca_0,C_GHB_00,=fb(variables, constants)
    
    fig,axs1=plt.subplots()
    for x in range(len(fb1)):
        axs1.plot(Ca_0,fb1[x],linestyle=line[x//len(cols)])
    plt.xscale("log")
    plt.xlabel("Concentration BlcR [M]")
    plt.ylabel("fraction of DNA bound")
    #plt.title("fraction of DNA bound per BlcR concentration with varying GHB concentrations, Hill_coefficient=1")
    plt.legend(["100nM","430nM","1.85uM","7.94uM","34.3uM","147uM","631uM","2.71mM","11.7mM","50.0mM" ])
    
    fig,axs2=plt.subplots()

    for x in range(len(fb2)):
        axs2.plot(Ca_0,fb2[x],linestyle=line[x//len(cols)])
    plt.xscale("log")
    plt.xlabel("Concentration BlcR [M]")
    plt.ylabel("fraction of DNA bound")
    #plt.title("fraction of DNA bound per BlcR concentration with varying GHB concentrations, Hill_coefficient=3.4")
    plt.legend(["100nM","430nM","1.85uM","7.94uM","34.3uM","147uM","631uM","2.71mM","11.7mM","50.0mM" ])
    fig,axs3=plt.subplots()
    axs3.plot(Ca_0,fb1[0])
    axs3.plot(Ca_0,fb2[0])
    plt.xscale("log")
    
    plt.xlabel("Concentration BlcR [M]")
    plt.ylabel("fraction of DNA bound")
    #plt.ylabel("gain of signal between GHB concentration mouth and drink")
    #plt.title("fraction of DNA bound")
    plt.legend(["hill coefficient=1"  , "hill coefficient=1.79" ])
    plt.show()


def plot_vary_kd_BlcR_DNA():
    variables=standard_variables()
    constants=standard_constants()
    kk,Kd_BlcR_DNA_0=vary_kd_BlcR_DNA(variables, constants)
    fig,axs1=plt.subplots()
    axs1.plot(Kd_BlcR_DNA_0,kk)
    plt.yscale("log")
    plt.xscale("log")
    plt.xlabel("Kd value of BlcR to DNA [M]")
    plt.ylabel("concentration of BlcR needed to bind 99% of DNA [M]")


def plot_vary_kd_BlcR_GHB():
    variables=standard_variables()
    constants=standard_constants()
    kk2,Kd_BlcR_GHB_0=vary_Kd_BlcR_GHB(variables, constants)
    fig,axs1=plt.subplots()
    axs1.plot(Kd_BlcR_GHB_0,kk2)
    plt.yscale("log")
    plt.xscale("log")
    plt.xlabel("Kd value of BlcR to GHB [M]")
    plt.ylabel("concentration of BlcR needed to bind 99% of DNA [M]")


def plot_sensitivity():
    variables=standard_variables()
    constants=standard_constants()
    Kd_BlcR_DNA_0,k1,k2=sensitivity(variables, constants)
    plt.plot(Kd_BlcR_DNA_0,k1)
    plt.plot(Kd_BlcR_DNA_0,k2)
    plt.xscale("log")        
    plt.yscale("log")
    plt.xlabel("Concentration BlcR [M]")
    plt.xlabel("Concentration GHB [M]")
    plt.legend(["Amount of GHB to unbind 99%" , "Amount of GHB to unbind 1%"])
    
def plot_sensitivity_kd():
    variables=standard_variables()
    constants=standard_constants()
    Kd_BlcR_DNA_0,k1,k2=sensitivity_kds(variables, constants)
    plt.plot(Kd_BlcR_DNA_0,k1)
    plt.plot(Kd_BlcR_DNA_0,k2)
    plt.xscale("log")        
    plt.yscale("log")
    plt.xlabel("Kd_BlcR_DNA [M]")
    plt.ylabel("Concentration GHB [M]")
    plt.legend(["Amount of GHB to unbind 99%" , "Amount of GHB to unbind 1%"])
    
def plot_signal_to_noise():
    variables=standard_variables()
    constants=standard_constants()
    Frac_cap, Ca_0=signal_to_noise(variables, constants)
    fig,axs1=plt.subplots()  
    for x in range(3):
        axs1.plot(Ca_0,Frac_cap[x]) 
        plt.xscale("log")
        plt.yscale("log")
        plt.xlabel("Concentration BlcR [M]")
        plt.ylabel("Signal to noise ratio")
        plt.legend(["Kd=395nM" , "Kd=39.5nM","Kd=3.95nM"])
def plot_optimal_BlcR():
    variables=standard_variables()
    constants=standard_constants()
    Frac_cap, Ca_0, lowerbound=signal_to_noise_max(variables,constants)
    plt.plot(Ca_0,Frac_cap)
    plt.xscale("log")
    plt.xlabel("Concentration BlcR [M]")
    plt.ylabel("signal to noise ratio")   
    




